#include "../VertexShader.h"

// _VF[_[̓
struct VS_INPUT
{
	float4 Position        : POSITION0 ;		// W( gXtH[ς )

#ifdef USE_DIFFUSE
	float4 Diffuse         : COLOR0 ;			// fBt[YJ[
#endif // USE_DIFFUSE

#ifdef USE_SPECULAR
	float4 Specular        : COLOR1 ;			// XyLJ[
#endif // USE_SPECULAR

#ifdef USE_TEXCOORD0
	float2 TexCoords0      : TEXCOORD0 ;		// eNX`WO
#endif // USE_TEXCOORD0

#ifdef USE_TEXCOORD1
	float2 TexCoords1      : TEXCOORD1 ;		// eNX`WP
#endif // USE_TEXCOORD1
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 Position        : SV_POSITION ;
	float4 Diffuse         : COLOR0 ;
	float2 TexCoords0      : TEXCOORD0 ;
	float2 TexCoords1      : TEXCOORD1 ;
} ;

// 2Dp
VS_OUTPUT VS2D_Normal( VS_INPUT VSInput )
{
	VS_OUTPUT VSOutput ;
	float4 Position;
	

	Position = VSInput.Position ;
	Position.w = 1.0f / Position.w ;
	Position.x *= Position.w ;
	Position.y *= Position.w ;
	Position.z *= Position.w ;


	// Wϊ
	VSOutput.Position.x = dot( Position, g_Base.ProjectionMatrix[ 0 ] ) ;
	VSOutput.Position.y = dot( Position, g_Base.ProjectionMatrix[ 1 ] ) ;
	VSOutput.Position.z = dot( Position, g_Base.ProjectionMatrix[ 2 ] ) ;
	VSOutput.Position.w = dot( Position, g_Base.ProjectionMatrix[ 3 ] ) ;


	// p[^Zbg
#ifdef USE_DIFFUSE
	VSOutput.Diffuse    = VSInput.Diffuse ;
#else  // USE_DIFFUSE
	VSOutput.Diffuse    = 1.0f ;
#endif // USE_DIFFUSE


#ifdef USE_TEXCOORD0
	VSOutput.TexCoords0 = VSInput.TexCoords0 ;
#else  // USE_TEXCOORD0
	VSOutput.TexCoords0 = 0.0f ;
#endif // USE_TEXCOORD0


#ifdef USE_TEXCOORD1
	VSOutput.TexCoords1 = VSInput.TexCoords1 ;
#else  // USE_TEXCOORD1
	VSOutput.TexCoords1 = 0.0f ;
#endif // USE_TEXCOORD1

	
	return VSOutput ;
}





// P]p_VF[_[̓
struct STRETCHRECT_VS_INPUT
{
	float2 Position        : POSITION0 ;		// W
	float2 TexCoords0      : TEXCOORD0 ;		// eNX`W0
	float2 TexCoords1      : TEXCOORD1 ;		// eNX`W1
} ;

// P]p_VF[_[̏o
struct STRETCHRECT_VS_OUTPUT
{
	float4 Position        : SV_POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
	float2 TexCoords1      : TEXCOORD1 ;
} ;

// P]p_VF[_[
STRETCHRECT_VS_OUTPUT StretchRect_VS( STRETCHRECT_VS_INPUT VSInput )
{
	STRETCHRECT_VS_OUTPUT VSOutput ;

	VSOutput.Position.x = VSInput.Position.x ;
	VSOutput.Position.y = VSInput.Position.y ;
	VSOutput.Position.z = 0.0f ;
	VSOutput.Position.w = 1.0f ;

	VSOutput.TexCoords0 = VSInput.TexCoords0 ;
	VSOutput.TexCoords1 = VSInput.TexCoords1 ;
	
	return VSOutput ;
}







// eNX`W8P]p_VF[_[̓
struct STRETCHRECT_TEX8_VS_INPUT
{
	float2 Position        : POSITION0 ;		// W
	float2 TexCoords0      : TEXCOORD0 ;		// eNX`W0
	float2 TexCoords1      : TEXCOORD1 ;		// eNX`W1
	float2 TexCoords2      : TEXCOORD2 ;		// eNX`W2
	float2 TexCoords3      : TEXCOORD3 ;		// eNX`W3
	float2 TexCoords4      : TEXCOORD4 ;		// eNX`W4
	float2 TexCoords5      : TEXCOORD5 ;		// eNX`W5
	float2 TexCoords6      : TEXCOORD6 ;		// eNX`W6
	float2 TexCoords7      : TEXCOORD7 ;		// eNX`W7
} ;

// eNX`W8P]p_VF[_[̏o
struct STRETCHRECT_TEX8_VS_OUTPUT
{
	float4 Position        : SV_POSITION ;
	float2 TexCoords0      : TEXCOORD0 ;
	float2 TexCoords1      : TEXCOORD1 ;
	float2 TexCoords2      : TEXCOORD2 ;
	float2 TexCoords3      : TEXCOORD3 ;
	float2 TexCoords4      : TEXCOORD4 ;
	float2 TexCoords5      : TEXCOORD5 ;
	float2 TexCoords6      : TEXCOORD6 ;
	float2 TexCoords7      : TEXCOORD7 ;
} ;

// eNX`W8P]p_VF[_[
STRETCHRECT_TEX8_VS_OUTPUT StretchRect_Tex8_VS( STRETCHRECT_TEX8_VS_INPUT VSInput )
{
	STRETCHRECT_TEX8_VS_OUTPUT VSOutput ;

	VSOutput.Position.x = VSInput.Position.x ;
	VSOutput.Position.y = VSInput.Position.y ;
	VSOutput.Position.z = 0.0f ;
	VSOutput.Position.w = 1.0f ;

	VSOutput.TexCoords0 = VSInput.TexCoords0 ;
	VSOutput.TexCoords1 = VSInput.TexCoords1 ;
	VSOutput.TexCoords2 = VSInput.TexCoords2 ;
	VSOutput.TexCoords3 = VSInput.TexCoords3 ;
	VSOutput.TexCoords4 = VSInput.TexCoords4 ;
	VSOutput.TexCoords5 = VSInput.TexCoords5 ;
	VSOutput.TexCoords6 = VSInput.TexCoords6 ;
	VSOutput.TexCoords7 = VSInput.TexCoords7 ;
	
	return VSOutput ;
}
